/* -----------------------------------------------------------------------------------------------
	unshared affine transformation
----------------------------------------------------------------------------------------------- */ 

module aft_um(
	input i_enable,
	input [7:0] i_data,
	output [7:0] o_data
	);

logic [7:0] data_t;
assign o_data = data_t;

always_comb 
	if (i_enable) begin
		data_t[7] = i_data[7]^i_data[6]^i_data[5]^i_data[4]^i_data[3];
		data_t[6] = i_data[6]^i_data[5]^i_data[4]^i_data[3]^i_data[2]^1'b1;	
		data_t[5] = i_data[5]^i_data[4]^i_data[3]^i_data[2]^i_data[1]^1'b1;
		data_t[4] = i_data[4]^i_data[3]^i_data[2]^i_data[1]^i_data[0];
		data_t[3] = i_data[7]^i_data[3]^i_data[2]^i_data[1]^i_data[0];
		data_t[2] = i_data[7]^i_data[6]^i_data[2]^i_data[1]^i_data[0];
		data_t[1] = i_data[7]^i_data[6]^i_data[5]^i_data[1]^i_data[0]^1'b1;
		data_t[0] = i_data[7]^i_data[6]^i_data[5]^i_data[4]^i_data[0]^1'b1;
	end
	else begin
		data_t = i_data;
	end
endmodule
