/* -----------------------------------------------------------------------------------------------
	1:3 Clk divider
----------------------------------------------------------------------------------------------- */ 

module clk_div(
	input i_clk,
	input i_rst_n,
	output logic o_sreg_clk
);

logic ff0;
logic ff1;
logic ff2;

assign o_sreg_clk = (ff2 || ff1);

always_ff @(posedge i_clk or negedge i_rst_n) begin
	if (!i_rst_n) begin
		ff0 <= 1'b0;
		ff1 <= 1'b0;

	end
	else begin
		ff0 <= !(ff0 || ff1);
		ff1 <= ff0;
	end
end

always_ff @(negedge i_clk) begin
	if (!i_rst_n) 
		ff2 <= 1'b0;
	else
		ff2 <= ff1;
end

endmodule 

