module gf24inv_um_norm(	
	input [3:0] i_data,
	output [3:0] o_data
);

// LSB (Y4) 
assign o_data[0] = i_data[2] ^ 					// y
		  (i_data[3] && i_data[1]) ^ 			// xz
		  (i_data[3] && i_data[0]) ^ 			// xv
		  (i_data[2] && i_data[0]) ^ 			// yv	
		  (i_data[3] && i_data[2] && i_data[1]);	// xyz

// LSB + 1 (Y3)
assign o_data[1] = i_data[3] ^ 					// x
		   i_data[2] ^ 					// y
		  (i_data[3] && i_data[1]) ^ 			// xz
		  (i_data[3] && i_data[0]) ^ 			// xv
		  (i_data[3] && i_data[2] && i_data[0]);	// xyv

// LSB + 2 (Y2)
assign o_data[2] = i_data[0] ^ 					// v
	 	  (i_data[3] && i_data[1]) ^ 			// xz
		  (i_data[2] && i_data[1]) ^ 			// yz
		  (i_data[2] && i_data[0]) ^ 			// yv
		  (i_data[3] && i_data[1] && i_data[0]);	// xzv

// MSB (Y1)
assign o_data[3] = i_data[1] ^					// z
		   i_data[0] ^					// v
		  (i_data[3] && i_data[1]) ^ 			// xz
	          (i_data[2] && i_data[1]) ^ 			// yz
		  (i_data[2] && i_data[1] && i_data[0]);	// yzv


endmodule

