module gf24mul_shared_norm(
	input [3:0] i_data_1,
	input [3:0] i_data_2,
	input [3:0] i_data_3,
	input [3:0] i_data_4,

	input [3:0] i_data_5,
	input [3:0] i_data_6,
	input [3:0] i_data_7,
	input [3:0] i_data_8,

	output [3:0] o_data_1,
	output [3:0] o_data_2,
	output [3:0] o_data_3
);

logic [3:0] a;
logic [3:0] b;
logic [3:0] c;
logic [3:0] d;
logic [3:0] e;
logic [3:0] f;
logic [3:0] g;
logic [3:0] h;

logic  [2:0] o_m;
logic  [2:0] o_n;
logic  [2:0] o_o;
logic  [2:0] o_p;

assign a = '{i_data_1[3], i_data_2[3], i_data_3[3], i_data_4[3]};
assign b = '{i_data_1[2], i_data_2[2], i_data_3[2], i_data_4[2]};
assign c = '{i_data_1[1], i_data_2[1], i_data_3[1], i_data_4[1]};
assign d = '{i_data_1[0], i_data_2[0], i_data_3[0], i_data_4[0]};

assign e = '{i_data_5[3], i_data_6[3], i_data_7[3], i_data_8[3]};
assign f = '{i_data_5[2], i_data_6[2], i_data_7[2], i_data_8[2]};
assign g = '{i_data_5[1], i_data_6[1], i_data_7[1], i_data_8[1]};
assign h = '{i_data_5[0], i_data_6[0], i_data_7[0], i_data_8[0]};

assign o_data_3 = '{o_m[0], o_n[0], o_o[0], o_p[0]};
assign o_data_2 = '{o_m[1], o_n[1], o_o[1], o_p[1]};
assign o_data_1 = '{o_m[2], o_n[2], o_o[2], o_p[2]};

assign o_m[0] = (((a[1] ^ a[2] ^ a[3]) && (e[1] ^ e[2])) ^ e[3]) ^
		(((c[1] ^ c[2] ^ c[3]) && (e[1] ^ e[2])) ^ e[3]) ^
		(((d[1] ^ d[2] ^ d[3]) && (e[1] ^ e[2])) ^ e[3]) ^
		(((b[1] ^ b[2] ^ b[3]) && (f[1] ^ f[2])) ^ f[3]) ^
		(((c[1] ^ c[2] ^ c[3]) && (f[1] ^ f[2])) ^ f[3]) ^
		(((a[1] ^ a[2] ^ a[3]) && (g[1] ^ g[2])) ^ g[3]) ^
		(((b[1] ^ b[2] ^ b[3]) && (g[1] ^ g[2])) ^ g[3]) ^
		(((c[1] ^ c[2] ^ c[3]) && (g[1] ^ g[2])) ^ g[3]) ^
		(((d[1] ^ d[2] ^ d[3]) && (g[1] ^ g[2])) ^ g[3]) ^
		(((a[1] ^ a[2] ^ a[3]) && (h[1] ^ h[2])) ^ h[3]) ^
		(((c[1] ^ c[2] ^ c[3]) && (h[1] ^ h[2])) ^ h[3]);

assign o_m[1] = (((a[0] ^ a[2]) && (e[0] ^ e[3])) ^ (a[0] && e[2]) ^ a[3]) ^
		(((c[0] ^ c[2]) && (e[0] ^ e[3])) ^ (c[0] && e[2]) ^ c[3]) ^
		(((d[0] ^ d[2]) && (e[0] ^ e[3])) ^ (d[0] && e[2]) ^ d[3]) ^
		(((b[0] ^ b[2]) && (f[0] ^ f[3])) ^ (b[0] && f[2]) ^ b[3]) ^
		(((c[0] ^ c[2]) && (f[0] ^ f[3])) ^ (c[0] && f[2]) ^ c[3]) ^
		(((a[0] ^ a[2]) && (g[0] ^ g[3])) ^ (a[0] && g[2]) ^ a[3]) ^
		(((b[0] ^ b[2]) && (g[0] ^ g[3])) ^ (b[0] && g[2]) ^ b[3]) ^
		(((c[0] ^ c[2]) && (g[0] ^ g[3])) ^ (c[0] && g[2]) ^ c[3]) ^
		(((d[0] ^ d[2]) && (g[0] ^ g[3])) ^ (d[0] && g[2]) ^ d[3]) ^
		(((a[0] ^ a[2]) && (h[0] ^ h[3])) ^ (a[0] && h[2]) ^ a[3]) ^
		(((c[0] ^ c[2]) && (h[0] ^ h[3])) ^ (c[0] && h[2]) ^ c[3]);

assign o_m[2] = (((a[1] ^ a[3]) && (e[0] ^ e[3])) ^ (a[0] && e[1]) ^ a[3] ^ e[3]) ^
		(((c[1] ^ c[3]) && (e[0] ^ e[3])) ^ (c[0] && e[1]) ^ c[3] ^ e[3]) ^
		(((d[1] ^ d[3]) && (e[0] ^ e[3])) ^ (d[0] && e[1]) ^ d[3] ^ e[3]) ^
		(((b[1] ^ b[3]) && (f[0] ^ f[3])) ^ (b[0] && f[1]) ^ b[3] ^ f[3]) ^
		(((c[1] ^ c[3]) && (f[0] ^ f[3])) ^ (c[0] && f[1]) ^ c[3] ^ f[3]) ^
		(((a[1] ^ a[3]) && (g[0] ^ g[3])) ^ (a[0] && g[1]) ^ a[3] ^ g[3]) ^
		(((b[1] ^ b[3]) && (g[0] ^ g[3])) ^ (b[0] && g[1]) ^ b[3] ^ g[3]) ^
		(((c[1] ^ c[3]) && (g[0] ^ g[3])) ^ (c[0] && g[1]) ^ c[3] ^ g[3]) ^
		(((d[1] ^ d[3]) && (g[0] ^ g[3])) ^ (d[0] && g[1]) ^ d[3] ^ g[3]) ^
		(((a[1] ^ a[3]) && (h[0] ^ h[3])) ^ (a[0] && h[1]) ^ a[3] ^ h[3]) ^
		(((c[1] ^ c[3]) && (h[0] ^ h[3])) ^ (c[0] && h[1]) ^ c[3] ^ h[3]);

assign o_n[0] = (((b[1] ^ b[2] ^ b[3]) && (e[1] ^ e[2])) ^ e[3]) ^
		(((c[1] ^ c[2] ^ c[3]) && (e[1] ^ e[2])) ^ e[3]) ^
		(((a[1] ^ a[2] ^ a[3]) && (f[1] ^ f[2])) ^ f[3]) ^
		(((b[1] ^ b[2] ^ b[3]) && (f[1] ^ f[2])) ^ f[3]) ^
		(((d[1] ^ d[2] ^ d[3]) && (f[1] ^ f[2])) ^ f[3]) ^
		(((a[1] ^ a[2] ^ a[3]) && (g[1] ^ g[2])) ^ g[3]) ^
		(((c[1] ^ c[2] ^ c[3]) && (g[1] ^ g[2])) ^ g[3]) ^
		(((b[1] ^ b[2] ^ b[3]) && (h[1] ^ h[2])) ^ h[3]) ^
		(((d[1] ^ d[2] ^ d[3]) && (h[1] ^ h[2])) ^ h[3]);

assign o_n[1] = (((b[0] ^ b[2]) && (e[0] ^ e[3])) ^ (b[0] && e[2]) ^ b[3]) ^
		(((c[0] ^ c[2]) && (e[0] ^ e[3])) ^ (c[0] && e[2]) ^ c[3]) ^
		(((a[0] ^ a[2]) && (f[0] ^ f[3])) ^ (a[0] && f[2]) ^ a[3]) ^
		(((b[0] ^ b[2]) && (f[0] ^ f[3])) ^ (b[0] && f[2]) ^ b[3]) ^
		(((d[0] ^ d[2]) && (f[0] ^ f[3])) ^ (d[0] && f[2]) ^ d[3]) ^
		(((a[0] ^ a[2]) && (g[0] ^ g[3])) ^ (a[0] && g[2]) ^ a[3]) ^
		(((c[0] ^ c[2]) && (g[0] ^ g[3])) ^ (c[0] && g[2]) ^ c[3]) ^
		(((b[0] ^ b[2]) && (h[0] ^ h[3])) ^ (b[0] && h[2]) ^ b[3]) ^
		(((d[0] ^ d[2]) && (h[0] ^ h[3])) ^ (d[0] && h[2]) ^ d[3]);

assign o_n[2] = (((b[1] ^ b[3]) && (e[0] ^ e[3])) ^ (b[0] && e[1]) ^ b[3] ^ e[3]) ^
		(((c[1] ^ c[3]) && (e[0] ^ e[3])) ^ (c[0] && e[1]) ^ c[3] ^ e[3]) ^
		(((a[1] ^ a[3]) && (f[0] ^ f[3])) ^ (a[0] && f[1]) ^ a[3] ^ f[3]) ^
		(((b[1] ^ b[3]) && (f[0] ^ f[3])) ^ (b[0] && f[1]) ^ b[3] ^ f[3]) ^
		(((d[1] ^ d[3]) && (f[0] ^ f[3])) ^ (d[0] && f[1]) ^ d[3] ^ f[3]) ^
		(((a[1] ^ a[3]) && (g[0] ^ g[3])) ^ (a[0] && g[1]) ^ a[3] ^ g[3]) ^
		(((c[1] ^ c[3]) && (g[0] ^ g[3])) ^ (c[0] && g[1]) ^ c[3] ^ g[3]) ^
		(((b[1] ^ b[3]) && (h[0] ^ h[3])) ^ (b[0] && h[1]) ^ b[3] ^ h[3]) ^
		(((d[1] ^ d[3]) && (h[0] ^ h[3])) ^ (d[0] && h[1]) ^ d[3] ^ h[3]);

assign o_o[0] = (((a[1] ^ a[2] ^ a[3]) && (e[1] ^ e[2])) ^ e[3]) ^
		(((b[1] ^ b[2] ^ b[3]) && (e[1] ^ e[2])) ^ e[3]) ^
		(((c[1] ^ c[2] ^ c[3]) && (e[1] ^ e[2])) ^ e[3]) ^
		(((d[1] ^ d[2] ^ d[3]) && (e[1] ^ e[2])) ^ e[3]) ^
		(((a[1] ^ a[2] ^ a[3]) && (f[1] ^ f[2])) ^ f[3]) ^
		(((c[1] ^ c[2] ^ c[3]) && (f[1] ^ f[2])) ^ f[3]) ^
		(((a[1] ^ a[2] ^ a[3]) && (g[1] ^ g[2])) ^ g[3]) ^
		(((b[1] ^ b[2] ^ b[3]) && (g[1] ^ g[2])) ^ g[3]) ^
		(((c[1] ^ c[2] ^ c[3]) && (g[1] ^ g[2])) ^ g[3]) ^
		(((a[1] ^ a[2] ^ a[3]) && (h[1] ^ h[2])) ^ h[3]) ^
		(((d[1] ^ d[2] ^ d[3]) && (h[1] ^ h[2])) ^ h[3]);

assign o_o[1] = (((a[0] ^ a[2]) && (e[0] ^ e[3])) ^ (a[0] && e[2]) ^ a[3]) ^
		(((b[0] ^ b[2]) && (e[0] ^ e[3])) ^ (b[0] && e[2]) ^ b[3]) ^
		(((c[0] ^ c[2]) && (e[0] ^ e[3])) ^ (c[0] && e[2]) ^ c[3]) ^
		(((d[0] ^ d[2]) && (e[0] ^ e[3])) ^ (d[0] && e[2]) ^ d[3]) ^
		(((a[0] ^ a[2]) && (f[0] ^ f[3])) ^ (a[0] && f[2]) ^ a[3]) ^
		(((c[0] ^ c[2]) && (f[0] ^ f[3])) ^ (c[0] && f[2]) ^ c[3]) ^
		(((a[0] ^ a[2]) && (g[0] ^ g[3])) ^ (a[0] && g[2]) ^ a[3]) ^
		(((b[0] ^ b[2]) && (g[0] ^ g[3])) ^ (b[0] && g[2]) ^ b[3]) ^
		(((c[0] ^ c[2]) && (g[0] ^ g[3])) ^ (c[0] && g[2]) ^ c[3]) ^
		(((a[0] ^ a[2]) && (h[0] ^ h[3])) ^ (a[0] && h[2]) ^ a[3]) ^
		(((d[0] ^ d[2]) && (h[0] ^ h[3])) ^ (d[0] && h[2]) ^ d[3]);

assign o_o[2] = (((a[1] ^ a[3]) && (e[0] ^ e[3])) ^ (a[0] && e[1]) ^ a[3] ^ e[3]) ^
		(((b[1] ^ b[3]) && (e[0] ^ e[3])) ^ (b[0] && e[1]) ^ b[3] ^ e[3]) ^
		(((c[1] ^ c[3]) && (e[0] ^ e[3])) ^ (c[0] && e[1]) ^ c[3] ^ e[3]) ^
		(((d[1] ^ d[3]) && (e[0] ^ e[3])) ^ (d[0] && e[1]) ^ d[3] ^ e[3]) ^
		(((a[1] ^ a[3]) && (f[0] ^ f[3])) ^ (a[0] && f[1]) ^ a[3] ^ f[3]) ^
		(((c[1] ^ c[3]) && (f[0] ^ f[3])) ^ (c[0] && f[1]) ^ c[3] ^ f[3]) ^
		(((a[1] ^ a[3]) && (g[0] ^ g[3])) ^ (a[0] && g[1]) ^ a[3] ^ g[3]) ^
		(((b[1] ^ b[3]) && (g[0] ^ g[3])) ^ (b[0] && g[1]) ^ b[3] ^ g[3]) ^
		(((c[1] ^ c[3]) && (g[0] ^ g[3])) ^ (c[0] && g[1]) ^ c[3] ^ g[3]) ^
		(((a[1] ^ a[3]) && (h[0] ^ h[3])) ^ (a[0] && h[1]) ^ a[3] ^ h[3]) ^
		(((d[1] ^ d[3]) && (h[0] ^ h[3])) ^ (d[0] && h[1]) ^ d[3] ^ h[3]);

assign o_p[0] = (((a[1] ^ a[2] ^ a[3]) && (e[1] ^ e[2])) ^ e[3]) ^
		(((c[1] ^ c[2] ^ c[3]) && (e[1] ^ e[2])) ^ e[3]) ^
		(((b[1] ^ b[2] ^ b[3]) && (f[1] ^ f[2])) ^ f[3]) ^
		(((d[1] ^ d[2] ^ d[3]) && (f[1] ^ f[2])) ^ f[3]) ^
		(((a[1] ^ a[2] ^ a[3]) && (g[1] ^ g[2])) ^ g[3]) ^
		(((d[1] ^ d[2] ^ d[3]) && (g[1] ^ g[2])) ^ g[3]) ^
		(((b[1] ^ b[2] ^ b[3]) && (h[1] ^ h[2])) ^ h[3]) ^
		(((c[1] ^ c[2] ^ c[3]) && (h[1] ^ h[2])) ^ h[3]) ^
		(((d[1] ^ d[2] ^ d[3]) && (h[1] ^ h[2])) ^ h[3]);

assign o_p[1] = (((a[0] ^ a[2]) && (e[0] ^ e[3])) ^ (a[0] && e[2]) ^ a[3]) ^
		(((c[0] ^ c[2]) && (e[0] ^ e[3])) ^ (c[0] && e[2]) ^ c[3]) ^
		(((b[0] ^ b[2]) && (f[0] ^ f[3])) ^ (b[0] && f[2]) ^ b[3]) ^
		(((d[0] ^ d[2]) && (f[0] ^ f[3])) ^ (d[0] && f[2]) ^ d[3]) ^
		(((a[0] ^ a[2]) && (g[0] ^ g[3])) ^ (a[0] && g[2]) ^ a[3]) ^
		(((d[0] ^ d[2]) && (g[0] ^ g[3])) ^ (d[0] && g[2]) ^ d[3]) ^
		(((b[0] ^ b[2]) && (h[0] ^ h[3])) ^ (b[0] && h[2]) ^ b[3]) ^
		(((c[0] ^ c[2]) && (h[0] ^ h[3])) ^ (c[0] && h[2]) ^ c[3]) ^
		(((d[0] ^ d[2]) && (h[0] ^ h[3])) ^ (d[0] && h[2]) ^ d[3]);

assign o_p[2] = (((a[1] ^ a[3]) && (e[0] ^ e[3])) ^ (a[0] && e[1]) ^ a[3] ^ e[3]) ^
		(((c[1] ^ c[3]) && (e[0] ^ e[3])) ^ (c[0] && e[1]) ^ c[3] ^ e[3]) ^
		(((b[1] ^ b[3]) && (f[0] ^ f[3])) ^ (b[0] && f[1]) ^ b[3] ^ f[3]) ^
		(((d[1] ^ d[3]) && (f[0] ^ f[3])) ^ (d[0] && f[1]) ^ d[3] ^ f[3]) ^
		(((a[1] ^ a[3]) && (g[0] ^ g[3])) ^ (a[0] && g[1]) ^ a[3] ^ g[3]) ^
		(((d[1] ^ d[3]) && (g[0] ^ g[3])) ^ (d[0] && g[1]) ^ d[3] ^ g[3]) ^
		(((b[1] ^ b[3]) && (h[0] ^ h[3])) ^ (b[0] && h[1]) ^ b[3] ^ h[3]) ^
		(((c[1] ^ c[3]) && (h[0] ^ h[3])) ^ (c[0] && h[1]) ^ c[3] ^ h[3]) ^
		(((d[1] ^ d[3]) && (h[0] ^ h[3])) ^ (d[0] && h[1]) ^ d[3] ^ h[3]);

endmodule
