
module gf28inv_um_poly (
	input i_clk,
	input i_rst_n,
	input [7:0] i_data,
	output [7:0] o_data
	);

logic [7:0]i_linmap;
logic [7:0]o_linmap;

logic [7:0]o_linmapinv;
logic [7:0]i_linmapinv;

logic [3:0]i_gfsqsc;
logic [3:0]o_gfsqsc;

logic [3:0]i_gfinv;
logic [3:0]o_gfinv;

logic [3:0]i_gfmul11;
logic [3:0]i_gfmul10;
logic [3:0]o_gfmul1;

logic [3:0]i_gfmul21;
logic [3:0]i_gfmul20;
logic [3:0]o_gfmul2;

logic [3:0]i_gfmul31;
logic [3:0]i_gfmul30;
logic [3:0]o_gfmul3;

logic [15:0] pipe_reg_1;
logic [11:0] pipe_reg_2;

linmap_um_poly im(
	.i_data(i_linmap),
	.o_data(o_linmap)
);

invlinmap_um_poly imv(
	.i_data(i_linmapinv),
	.o_data(o_linmapinv)
);

gf24sqsc_um_poly gfsqsc(
	.i_data(i_gfsqsc),
	.o_data(o_gfsqsc)	
);

gf24inv_um_poly gfinv(
	.i_data(i_gfinv),
	.o_data(o_gfinv)
);

gf24mul_um_poly gfmul1(
	.i_data1(i_gfmul11),
	.i_data0(i_gfmul10),
	.o_data(o_gfmul1)
);

gf24mul_um_poly gfmul2(
	.i_data1(i_gfmul21),
	.i_data0(i_gfmul20),
	.o_data(o_gfmul2)
);

gf24mul_um_poly gfmul3(
	.i_data1(i_gfmul31),
	.i_data0(i_gfmul30),
	.o_data(o_gfmul3)
);

assign i_linmap = i_data;
assign i_gfsqsc = o_linmap[7:4];
assign i_gfinv = pipe_reg_1[11:8] ^ pipe_reg_1[3:0];
assign i_gfmul11 = o_linmap[7:4]^o_linmap[3:0];
assign i_gfmul10 = o_linmap[3:0];
assign i_gfmul21 = pipe_reg_2[11:8];
assign i_gfmul20 = pipe_reg_2[7:4];
assign i_gfmul31 = pipe_reg_2[7:4];
assign i_gfmul30 = pipe_reg_2[3:0];
assign i_linmapinv[7:4] = o_gfmul2;
assign i_linmapinv[3:0] = o_gfmul3;
assign o_data = o_linmapinv;

always_ff @(posedge i_clk or negedge i_rst_n) begin
	if (!i_rst_n) begin
		pipe_reg_1 <= '{default: 0};
		pipe_reg_2 <= '{default: 0};
	end
	else begin
		// Set Pipeline Register 1
		pipe_reg_1[15:12] <= o_linmap[7:4];
		pipe_reg_1[11:8] <= o_gfsqsc;
		pipe_reg_1[7:4] <= o_linmap[7:4] ^ o_linmap[3:0];
		pipe_reg_1[3:0] <= o_gfmul1;
	
		// Set Pipeline Register 2
		pipe_reg_2[11:8] <= pipe_reg_1[15:12];
		pipe_reg_2[7:4] <= o_gfinv;
		pipe_reg_2[3:0] <= pipe_reg_1[7:4];

	end
end

endmodule 
