// Inverse linear map from composite to binary field representation.

module invlinmap_shared_poly(
	input [7:0] i_share_1,
	input [7:0] i_share_2,
	input [7:0] i_share_3,

	output [7:0] o_share_1,
	output [7:0] o_share_2,
	output [7:0] o_share_3
);

// Share 1
assign o_share_1[7] = i_share_1[7]^i_share_1[6]^i_share_1[5]^i_share_1[1];
assign o_share_1[6] = i_share_1[6]^i_share_1[2];
assign o_share_1[5] = i_share_1[6]^i_share_1[5]^i_share_1[1];
assign o_share_1[4] = i_share_1[6]^i_share_1[5]^i_share_1[4]^i_share_1[2]^i_share_1[1];
assign o_share_1[3] = i_share_1[5]^i_share_1[4]^i_share_1[3]^i_share_1[2]^i_share_1[1];
assign o_share_1[2] = i_share_1[7]^i_share_1[4]^i_share_1[3]^i_share_1[2]^i_share_1[1];
assign o_share_1[1] = i_share_1[5]^i_share_1[4];
assign o_share_1[0] = i_share_1[6]^i_share_1[5]^i_share_1[4]^i_share_1[2]^i_share_1[0];

// Share 2
assign o_share_2[7] = i_share_2[7]^i_share_2[6]^i_share_2[5]^i_share_2[1];
assign o_share_2[6] = i_share_2[6]^i_share_2[2];
assign o_share_2[5] = i_share_2[6]^i_share_2[5]^i_share_2[1];
assign o_share_2[4] = i_share_2[6]^i_share_2[5]^i_share_2[4]^i_share_2[2]^i_share_2[1];
assign o_share_2[3] = i_share_2[5]^i_share_2[4]^i_share_2[3]^i_share_2[2]^i_share_2[1];
assign o_share_2[2] = i_share_2[7]^i_share_2[4]^i_share_2[3]^i_share_2[2]^i_share_2[1];
assign o_share_2[1] = i_share_2[5]^i_share_2[4];
assign o_share_2[0] = i_share_2[6]^i_share_2[5]^i_share_2[4]^i_share_2[2]^i_share_2[0];

// Share 3
assign o_share_3[7] = i_share_3[7]^i_share_3[6]^i_share_3[5]^i_share_3[1];
assign o_share_3[6] = i_share_3[6]^i_share_3[2];
assign o_share_3[5] = i_share_3[6]^i_share_3[5]^i_share_3[1];
assign o_share_3[4] = i_share_3[6]^i_share_3[5]^i_share_3[4]^i_share_3[2]^i_share_3[1];
assign o_share_3[3] = i_share_3[5]^i_share_3[4]^i_share_3[3]^i_share_3[2]^i_share_3[1];
assign o_share_3[2] = i_share_3[7]^i_share_3[4]^i_share_3[3]^i_share_3[2]^i_share_3[1];
assign o_share_3[1] = i_share_3[5]^i_share_3[4];
assign o_share_3[0] = i_share_3[6]^i_share_3[5]^i_share_3[4]^i_share_3[2]^i_share_3[0];



endmodule
