module kex_rcon(
	input [0:3][7:0] i_data,
	input [3:0] i_round,
	output [0:3][7:0] o_data
);

logic [7:0]rcon;

assign o_data = {i_data[0] ^ rcon, i_data[1:3]};

always_comb
begin

	unique case (i_round)
		1:	rcon = 8'h01;
		2:	rcon = 8'h02;
		3:	rcon = 8'h04;
		4:	rcon = 8'h08;
		5:	rcon = 8'h10;
		6:	rcon = 8'h20;
		7:	rcon = 8'h40;
		8:	rcon = 8'h80;
		9:	rcon = 8'h1B;
		10:	rcon = 8'h36;
		default:rcon = '{default: 0};
	endcase
end

endmodule
