
module kex_sbox(
	input [7:0] i_data,
	output [7:0] o_data
	);

logic [7:0]i_aft;
logic [7:0]o_aft;

logic [7:0]i_linmap;
logic [7:0]o_linmap;

logic [7:0]o_linmapinv;
logic [7:0]i_linmapinv;

logic [3:0]i_gfsqsc;
logic [3:0]o_gfsqsc;

logic [3:0]i_gfinv;
logic [3:0]o_gfinv;

logic [3:0]i_gfmul11;
logic [3:0]i_gfmul10;
logic [3:0]o_gfmul1;

logic [3:0]i_gfmul21;
logic [3:0]i_gfmul20;
logic [3:0]o_gfmul2;

logic [3:0]i_gfmul31;
logic [3:0]i_gfmul30;
logic [3:0]o_gfmul3;

kex_aft af(
	.i_data(i_aft), 
	.o_data(o_aft)
);

kex_linmap im(
	.i_data(i_linmap),
	.o_data(o_linmap)
);

kex_invlinmap imv(
	.i_data(i_linmapinv),
	.o_data(o_linmapinv)
);

kex_gf24sqsc gfsqsc(
	.i_data(i_gfsqsc),
	.o_data(o_gfsqsc)	
);

kex_gf24inv gfinv(
	.i_data(i_gfinv),
	.o_data(o_gfinv)
);

kex_gf24mul gfmul1(
	.i_data1(i_gfmul11),
	.i_data0(i_gfmul10),
	.o_data(o_gfmul1)
);

kex_gf24mul gfmul2(
	.i_data1(i_gfmul21),
	.i_data0(i_gfmul20),
	.o_data(o_gfmul2)
);

kex_gf24mul gfmul3(
	.i_data1(i_gfmul31),
	.i_data0(i_gfmul30),
	.o_data(o_gfmul3)
);

assign i_linmap = i_data;
assign i_gfsqsc = o_linmap[7:4];
assign i_gfinv = o_gfsqsc^o_gfmul1;
assign i_gfmul11 = o_linmap[7:4]^o_linmap[3:0];
assign i_gfmul10 = o_linmap[3:0];
assign i_gfmul21 = o_linmap[7:4];
assign i_gfmul20 = o_gfinv;
assign i_gfmul31 = o_gfinv;
assign i_gfmul30 = o_linmap[7:4]^o_linmap[3:0];
assign i_linmapinv[7:4] = o_gfmul2;
assign i_linmapinv[3:0] = o_gfmul3;
assign i_aft = o_linmapinv;
assign o_data = o_aft;

endmodule 

















