module mixcol(
	input [0:3][7:0] i_data,
	output [0:3][7:0] o_data
);

logic [7:0] xt_1;
logic [7:0] xt_2;
logic [7:0] xt_3;
logic [7:0] xt_4;

logic [7:0] o_xt_1;
logic [7:0] o_xt_2;
logic [7:0] o_xt_3;
logic [7:0] o_xt_4;


xtime xt1(
	.i_data(xt_1),
	.o_data(o_xt_1)
);

xtime xt2(
	.i_data(xt_2),
	.o_data(o_xt_2)
);

xtime xt3(
	.i_data(xt_3),
	.o_data(o_xt_3)
);

xtime xt4(
	.i_data(xt_4),
	.o_data(o_xt_4)
);

assign xt_1 = i_data[0] ^ i_data[1];
assign xt_2 = i_data[1] ^ i_data[2];
assign xt_3 = i_data[2] ^ i_data[3];
assign xt_4 = i_data[3] ^ i_data[0];

assign o_data[0] = o_xt_1 ^ xt_3 ^ i_data[1];
assign o_data[1] = o_xt_2 ^ xt_4 ^ i_data[2];
assign o_data[2] = o_xt_3 ^ xt_1 ^ i_data[3];
assign o_data[3] = o_xt_4 ^ xt_2 ^ i_data[0];

endmodule 
