module sbox128_um_norm(
	input i_clk,
	input i_rst_n,
	input i_encrypt,
	input [0:3][0:3][7:0] i_data,
	output [0:3][0:3][7:0] o_data

);

logic [0:3][0:3][7:0] i_sb;
logic [0:3][0:3][7:0] o_sb;


genvar index1;  
genvar index2;  
generate  
for (index1=0; index1 < 4; index1 = index1 + 1)  begin
	for (index2=0; index2 < 4; index2=index2+1)  
  	begin: gen_blocks_blocks  
    	aft_um aft_inst (  
      		.i_enable(i_encrypt), 
      		.i_data(o_sb[index1][index2]),
		.o_data(o_data[index1][index2])
	);  

	aft_inv_um afti_inst(
		.i_enable(!i_encrypt),	
		.i_data(i_data[index1][index2]),
		.o_data(i_sb[index1][index2])
	);
	gf28inv_um_norm sb_inst(
		.i_clk(i_clk),
		.i_rst_n(i_rst_n),
		.i_data(i_sb[index1][index2]),
		.o_data(o_sb[index1][index2])
	);
  end  
end
endgenerate  

endmodule
