module state_logic(
	input i_clk,
	input i_enable,
	input i_rst_n,
	input [0:3][0:3][7:0] i_data,
	input [1:0] i_mc_mode,
	output [0:3][0:3][7:0] o_data
);

logic [0:3][0:3][7:0] int_state;
logic [0:3][0:3][7:0] int_state2;
logic clk;


assign clk = i_clk && i_enable;

sr_mc srmc(
	.i_data(int_state),
	.i_mode(i_mc_mode),
	.o_data(o_data)
);

always_ff @(posedge clk or negedge i_rst_n) begin
	if (!i_rst_n) begin
		int_state <= '{default: 0};
	end
	else begin
		int_state <= i_data;
	end

end

endmodule


